package cz.fi.muni.pa165.entity;

import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.TestInstance;

import org.junit.jupiter.api.Test;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

import static org.testng.Assert.assertEquals;

@TestInstance(TestInstance.Lifecycle.PER_CLASS)
public class PlayerEntityTest {

    private EntityManagerFactory emf = Persistence.createEntityManagerFactory("default");

    private TeamEntity team;
    private PlayerEntity playerA;
    private PlayerEntity playerB;

    @BeforeAll
    void init() {
        team = new TeamEntity();
        team.setName("Autisti");
        playerA = new PlayerEntity("Player A");
        playerB = new PlayerEntity("Player B");

        team.addPlayerToTheTeam(playerA);
        team.addPlayerToTheTeam(playerB);
        playerA.setTeam(team);
        playerB.setTeam(team);

        EntityManager em = emf.createEntityManager();
        try {
            em.getTransaction().begin();
            em.persist(team);
            em.persist(playerA);
            em.persist(playerB);
            em.getTransaction().commit();
        } finally {
            if (em != null) em.close();
        }
    }

    @Test
    void relationshipPlayerA() {
        PlayerEntity player;
        EntityManager em = null;
        try {
            em = emf.createEntityManager();
            em.getTransaction().begin();
            player = em.find(PlayerEntity.class, playerA.getId());
            assertEquals(player.getTeam(), team);
            em.getTransaction().commit();
        } finally {
            if (em != null) em.close();
        }
    }

    @Test
    void relationshipPlayerB() {
        PlayerEntity player;
        EntityManager em = null;
        try {
            em = emf.createEntityManager();
            em.getTransaction().begin();
            player = em.find(PlayerEntity.class, playerB.getId());
            assertEquals(player.getTeam(), team);
            em.getTransaction().commit();
        } finally {
            if (em != null) em.close();
        }
    }

    @Test
    void relationshipTeam() {
        TeamEntity team;
        EntityManager em = null;
        try {
            em = emf.createEntityManager();
            em.getTransaction().begin();
            team = em.find(TeamEntity.class, this.team.getId());
            assertEquals(team.getPlayerList().size(), 2);
            em.getTransaction().commit();
        } finally {
            if (em != null) em.close();
        }
    }
}
